%! TEX root = ../../master.tex
\lecture[]{Fr 14 Okt 2022}{Stalks}

Throughout, let $X$ be a topological space.
Presheaves associate objects to open sets, and it would be great to assign objects to points.
For this we need the notion of limits.

\begin{definition}
Let $(I,\leq)$ be a pair where $I$ is a set and $\leq$ is a binary relation.
  \begin{enumerate}
      \item $(I,\leq)$ is \vocab{preordered} if $\leq$ is reflexive and transitive
      \item $(I,\leq)$ is a \vocab{poset} if it is preordered and $\leq$ is anti-symmetric.
      \item $(I,\leq)$ is a \vocab{directed set} if it is preordered and for all $i,j\in I$ there is $k\in I$ such that $i,j\leq k$.
  \end{enumerate}
\end{definition}

\begin{example}
  \label{ex:directed-sets}
  \leavevmode
  \begin{enumerate}
      \item Let $I=\{U\leq X:U\ \text{open}\}$ and $U\leq V:\Longleftrightarrow U\subseteq V$. Then $I$ is a directed poset.
      \item For $x\in X$, let $I_x\coloneqq\{U\subseteq X:U\ \text{open},\ x\in U\}$. This is a directed poset.
  \end{enumerate}
\end{example}

\begin{definition}
  \label{def:directed-system}
  Let $(I,\leq)$ be a directed set and $\mathcat{C}$ a category.
  A \vocab{directed system} in $\mathcat{C}$ indexed by $I$ is a pair
  $( \set{A_i}_{i\in I}, \set{ \rho_{ij} }_{i,j\in I, i\leq j})$
  where the $A_i$ are objects in $\mathcat{C}$ and the $\rho_{ij} \colon A_i \to A_j$
  are morphisms in $\mathcat{C}$ such that $\rho_{ii} = \id_{A_i}$ and
  $\rho_{ik} = \rho_{jk} \circ \rho_{ij}$ for all $i,j,k\in I$ with $i\leq j\leq k$.
\end{definition}

\begin{trivial}
  \autoref{def:directed-system} can also be phrased differently:
  As $I$ is a poset, we can view it as a category in the natural way,
  i.e.~$\Ob(I) = I$ and
  \[
    \Mor_{I}(i,j) = \begin{cases}
      \star & i \leq j \\
      \emptyset & else
    \end{cases}
  \]
  with the obvious composition.
  Then, a directed system in $\mathcat{C}$ is just a functor $I \to \mathcat{C}$.
\end{trivial}

\begin{example}
  If $\mathcal{F}$ is a preheaf of $\mathcat{C}$ on $X$ and $I_x$ is as in \autoref{ex:directed-sets},
  then $(\{\mathcal{F}(U_i),\{\rho_{U_j,U_i}\}_{U_i\subseteq U_j}\})$ is a directed system in $\mathcat{C}$,
  indexed by $I^{\op}$
  (note the opposite category here, since the order is reversed).
\end{example}

\begin{definition}
  Let $(I,\leq)$ be a directed set
  and consider a category $\mathcat{C}$ with a directed system
  $(\{A_i\}_{i\in I},\{\rho_{ij}\}_{i,j\in I,i\leq j})$.
  The \vocab{directed limit} of $(\{A_i\},\{\rho_{ij}\})$ is a pair
  $(\directlimit_{i\in I} A_i, \set{ \rho_i }_{i\in I} )$
  where $\directlimit_{i\in I} A_i$ is in $\mathcat{C}$ and
  $\rho_i \colon A_i \to \directlimit_{i\in I} A_i$ are morphisms such that

  \begin{enumerate}
      \item We have $\rho_j \circ \rho_{ij} = \rho_i$ for all $i$, $j \in I$ with $i \leq j$.
      \item For all objects $A$ in $\mathcat{C}$ and morphisms $f_i \colon A_i \to A$
        such that $f_j \circ p_{ij} = f_i$ for all $i,j\in I$ with $i\leq j$,
        there exists a unique map $f \colon \directlimit_{i\in I} A_i \to A$ such that $f \circ \rho_i = f_i$.
  \end{enumerate}
  \[
    \begin{tikzcd}
      A_i
      \ar{dd}[swap]{\rho _{ij}}
      \ar{dr}{\rho_i}
      \ar[bend left = 30]{drr}{f_i}
      \\
      &
      \directlimit A_i
      \ar["\exists !" description, dashed]{r}
      &
      A
      \\
      A_j
      \ar{ur}[swap]{\rho_j}
      \ar[bend right = 30]{urr}[swap]{f_j}
    \end{tikzcd}
  \]
\end{definition}



\begin{remark}
  \leavevmode
  \begin{enumerate}
      \item As an initial object (in the cocone category over $I$),
        the pair $(\directlimit A_i,\{\rho_i\})$ is unique up to unique isomorphism.
      \item Direct limits are a special case of colimits.
  \end{enumerate}
\end{remark}

\begin{example}
As an abbreviation, let $(*)=(\{A_i\}_{i\in I},\{\rho_{ij}\}_{i,j\in I,i\leq j})$.
  \begin{enumerate}
      \item Let $(*)$ be a directed system in $\Set$. Define
      \[
        \directlimit_{i\in I} A_i
        \coloneqq
        \faktor{ \coprod\limits_{i\in I} A_i } { \sim }
      \]
      where $a_i \sim a_j $ if and only if there exists $k\in I$ with $i,j\leq k$
      such that $\rho_{ij}(a_i)=\rho_{jk}(a_j)$
      and let $\rho_i$ be the canonical map $A_i\to \coprod_{i\in I}A_i\to\coprod_{i\in I}A_i/\sim$.
      Then, $\directlimit_{i\in I} A_i$ is the direct limit of $(*)$.

      \item If $(*)$ is a directed system in $\Ab$, we can set
      \[
      \directlimit_{i\in I}A_i\coloneqq \bigoplus_{i\in I}A_i/N
      \]
      where $N$ is the (normal) subgroup generated by the $a_i-\rho_{ij}(a_i)$
      for $a_i\in A_i$, $i,j\in I$, $i\leq j$.
      Then, together with the canonical maps
      \[
        \rho_i \colon
        A_i \to \bigoplus_{i\in I} A_i \to \bigoplus_{i\in I} A_i/N.
      \]
      \item In fact, the natural map
      \[
        \faktor { \coprod\limits_{i\in I} A_i } { \sim }
        \to
        \faktor{ \bigoplus_{i\in I} A_i } {N}
      \]
      is a bijection (where on the left the coproduct is to be interpreted in $\Set$, of course).
  \end{enumerate}
\end{example}

You should check the following important result by hand.

\begin{fact}
  \label{fact:directed-limits-in-ab-are-exact}
  Taking directed limits in $\Ab$ is exact:
  For all directed sets $I$ and all directed systems $\{M_i\},\{N_i\},\{P_i\}$
  indexed by $I$ and collections of commutative diagrams
    \[
      \begin{tikzcd}
        0 & {M_i} & {N_i} & {P_i} & 0 \\
        0 & {M_j} & {N_j} & {P_j} & 0
        \arrow[from=1-1, to=1-2]
        \arrow[from=1-2, to=1-3]
        \arrow[from=1-3, to=1-4]
        \arrow[from=1-4, to=1-5]
        \arrow[from=2-1, to=2-2]
        \arrow[from=2-2, to=2-3]
        \arrow[from=2-3, to=2-4]
        \arrow[from=2-4, to=2-5]
        \arrow[from=1-2, to=2-2]
        \arrow[from=1-3, to=2-3]
        \arrow[from=1-4, to=2-4]
      \end{tikzcd}
    \]
  with exact rows, also the induced sequence
  \[
  0\to\directlimit M_i\to\directlimit N_i\to\directlimit P_i\to 0
  \]
  is exact.
\end{fact}

\begin{definition}[Stalk]
  \label{def:stalk}
  Let $\mathcat{C}$ be a category with direct limits.
  Let $x\in X$ be a point and let $\mathcal{F}$ be a preheaf of $\mathcat{C}$ on $X$.
  The \vocab{stalk} of $\mathcal{F}$ at $x$ is 
  \[
    \mathcal{F}_x
    =
    \directlimit_{x\in U} \mathcal{F}(U)
    \coloneqq
    \directlimit_{U\in I_x} \mathcal{F}(U).
  \]
\end{definition}

\begin{remark}[Notation]
For $s\in\mathcal{F}(U)$, we write $s_x$ for the image of $s$ in $\mathcal{F}_x$ and call it \vocab{germ} of $s$ at $x$.
\end{remark}

\begin{remark}+
  If the sections are functions,
  note that the germ contains much more information than just the value of a function.
  For example, considering smooth functions,
  from the germ we know the values of all the derrivatives at the point.
\end{remark}

\begin{remark}
  A morphism of presheaves $\varphi \colon \mathcal{F} \to \mathcal{G}$
  induces a morphism $\varphi_x \colon \mathcal{F}_x \to \mathcal{G}_x$ for every $x\in X$.
\end{remark}

\begin{remark}
  Let $x\in X$ and $\mathcal{F}$ a presheaf of $\Set, \Ab, \ldots$, then
  \begin{enumerate}
      \item For all $U\subseteq X$ open and all $x\in U$, $s,t\in\mathcal{F}(U)$,
        we have $s_x=t_x$ if and only if there exists $V\subseteq U$ open with $x\in V$ such that $s|_V=t|_V$.
      \item For all germs $s\in\mathcal{F}_x$ there exists $U\subseteq X$ open
        with $x\in U$ and $t\in\mathcal{F}(U)$ such that $t_x=s$.
  \end{enumerate}
\end{remark}

Every sheaf is a presheaf, so we have a forgetful functor $\Sh_\mathcat{C}(X)\to\PSh_\mathcat{C}(X)$.
It is a natural question whether there is an interesting (adjoint) functor in the other direction,
which we will construct now:

\begin{definition}[Sheafification]
  \label{def:sheafification}
  Let $\mathcal{F}$ be a preheaf of $\Set,\Ab,\ldots$ on $X$.
  The \vocab{sheafification} of $\mathcal{F}$ is the sheaf $\mathcal{F}^+$ defined by
  \[
    \mathcal{F}^+(U)
    \coloneqq
    \set{ s \colon U \to \coprod_{i\in I} \mathcal{F}_x : \text{$s$ satisfies $(i)$ and $(ii)$} },
  \]
  where
  \begin{enumerate}[(i)]
      \item For all $x\in U$, we have $s(x)\in\mathcal{F}_x$.
      \item For all $x\in U$ there exists an open $V\subseteq U$ with $x\in V$ and $t\in\mathcal{F}(V)$ such that $t_y=s(y)$ for all $y\in V$.
  \end{enumerate}
\end{definition}


\begin{remark}
  \leavevmode
  \begin{enumerate}
      \item $\mathcal{F}^+$ is a sheaf.
      \item Sheafification is functorial:
        For $\varphi\colon \mathcal{F}\to\mathcal{G}$ a morphism of presheaves,
        the collection $\varphi^+(U)\colon\mathcal{F}^+(U)\to\mathcal{G}^+(U)$,
        $s\mapsto (\coprod_{x\in U}\varphi_x)\circ s$
        yields a morphism $\mathcal{F}^+ \to \mathcal{G}^+$.
      \item There exists a natural morphism
        $\iota_\mathcal{F}\colon \mathcal{F}\to\mathcal{F}^+$ defined by
        $\iota_\mathcal{F}(U)(s)\colon x\mapsto s_x$.
      \item For all $s\in\mathcal{F}^+(U)$ there exists an open cover
        $U=\bigcup_{i\in I}U_i$ and $s_i\in\mathcal{F}(U_i)$ such that
        $s|_{U_i}=\iota_\mathcal{F}(U_i)(s_i)$
        (this is a different way of phrasing condition $(ii)$ in \autoref{def:sheafification}).
      \item For all $x\in X$,
        the map $\iota_{\mathcal{F},x}\colon\mathcal{F}_x\to\mathcal{F}_x^+$ is an isomorphism.
  \end{enumerate}
\end{remark}


\begin{proposition}
  \label{prop:universal-property-of-sheafification}
For all morphisms $\varphi \colon \mathcal{F} \to \mathcal{G}$
  such that $\mathcal{G}$ is a sheaf,
  there exists a unique morphism $\varphi^+\colon\mathcal{F}^+\to \mathcal{G}$
  such that $\varphi=\varphi^+\circ\iota_\mathcal{F}$.

  \[
    \begin{tikzcd}[column sep = tiny]
      \mathcal{F} \ar{rr}{ι_{\mathcal{F}}} \ar[swap]{dr}{\varphi } & & \mathcal{F}^+ \ar[dashed]{dl}{\varphi ^+} \\
    & \mathcal{G}
    \end{tikzcd}
  \]
\end{proposition}

\begin{remark}+
  we do not know yet that the sheafification of a sheaf is the sheaf itself,
  this is in fact equivalent to \autoref{prop:universal-property-of-sheafification}
  using the functoriality of $\mathcal{F}^+$.
\end{remark}

\begin{proof}
  Let $U\subseteq X$ be open and $s\in\mathcal{F}^+(U)$.
  Then there exists an open cover $U=\bigcup_{i\in I}U_i$ and
  $s_i\in \mathcal{F}(U_i)$ such that $\iota_\mathcal{F}(U_i)(s_i)=s|_{U_i}$.
  Since we want $\varphi=\varphi^+\circ\iota_\mathcal{F}$, we have to set
  \[
    \varphi^+(U_i)(s|_{U_i})\coloneqq\varphi(U_i)(s_i).
  \]
  Since $\mathcal{G}$ is a sheaf and $\varphi$ is a morphism of presheaves, 
  \[
    \varphi(U_i)(s_i)|_{U_i\cap U_j}
    =
    \varphi(U_i\cap U_j)(s_i|_{U_i\cap U_j})
    =
    \varphi(U_j)(s_j)|_{U_i\cap U_j}.
  \]
  Now we can lift uniquely to a section $t\in\mathcal{G}(U)$ with
  $t|_{U_i}=\varphi(U_i)(s_i)$.
  For $\varphi^+$ to be a morphism,
  we have to set $\varphi^+(U)(s)\coloneqq t$.
  You can check that $\varphi^+$ is compatible with restriction maps.
\end{proof}

\begin{corollary}+
  For a sheaf $\mathcal{F}$,
  the morphism of presheaves
  $ι_{\mathcal{F}}\colon  \mathcal{F} \to \mathcal{F}^+$
  is an isomorphism.
\end{corollary}

\begin{remark}
  \autoref{prop:universal-property-of-sheafification}
  shows that we have a bijection
  \[
    \Hom_{\Sh(X)}(\mathcal{F}^+,\mathcal{G})\leftrightarrow\Hom_{\PSh(X)}(\mathcal{F},\mathcal{G})
  \]
  that is natural in $\mathcal{F}$ and $\mathcal{G}$.
  Thus, sheafification $(-)^+$ is left-adjoint to the forgetful functor $\Sh(X) \to \PSh(X)$.
\end{remark}


\begin{proposition}
  Let $X=\Spec A$, recall the notation $D(a)=\Spec(A) \setminus  \mathcal{V}(a)$.
  For all $a\in A$, there exist isomorphisms $\varphi_a\colon A_a\to\mathcal{O}_X(D(a))$ such that for all $b\in A$ with $D(b)\subseteq D(a)$, we have
  \[
    \begin{tikzcd}
      {A_a} & {\mathcal{O}_X(D(a))} \\
      {A_b} & {\mathcal{O}_X(D(b))}
      \arrow["{\varphi_a}", from=1-1, to=1-2]
      \arrow["{\varphi_b}", from=2-1, to=2-2]
      \arrow["{\text{localisation}}"', from=1-1, to=2-1]
      \arrow["{\text{restriction}}", from=1-2, to=2-2]
    \end{tikzcd}
  \]
\end{proposition}

\begin{proof}
  Define $\varphi_a\colon A_a\to \mathcal{O}_X(D(a)),\ s/a^n\mapsto (\mathfrak{p}\mapsto s/a^n\in A_\mathfrak{p})$. This makes the diagram commute. We have to show that $\varphi_a$ is an isomorphism. For injectivity, assume that $\varphi_a(s/a^n)=0$. Let $I=\mathrm{Ann}(s)=\{r\in A:rs=0\}$. Since $s/a^n=0\in A_\mathfrak{p}$, for all $\mathfrak{p}\in D(a)$, we have $I\nsubseteq \mathfrak{p}$ for all $a\notin\mathfrak{p}$. So $V(I)\subseteq V(a)$, and thus $a\in\sqrt{I}$. Thus, there exists $m\geq 1$ such that $a^ms=0$, and thus $s/a^n=0$ in $A_a$. Let us prove surjectivity. Let $s\in\mathcal{O}_X(D(a))$. By the definition of $\mathcal{O}_X$ and because $D(b_i)$ form a basis of the space, we find $a_i,g_i,h_i\in A$ such that $D(a)=\bigcup_{i\in I}D(h_i)$ with $D(h_i)\subseteq D(g_i)$ and $s(q)=a_i/g_i$ for all $q\in D(h_i)$.

  \begin{claim}
    We can choose $g_i=h_i$.
  \end{claim}

  \begin{proof}
    We know that $D(h_i) \subset D(g_i)$.
    Thus, $\mathcal{V}(g_i) \subset \mathcal{V}(h_i)$,
    so $h_i \in \sqrt{(g_i)}$.
    Thus, there is some $c_i \in A$ and $n>1$ such that
    $h_i^n = c_i \cdot g_i$.
    Now, replace $h_i$ by $h_i^n$ and $a_i$ by $a_i c_i$,
    since then $\frac { a_i c_i } { h_i^n } = \frac { a_i } { g_i } $.
  \end{proof}

  \begin{claim}
    We can choose $I$ finite.
  \end{claim}

  \begin{proof}
    Have $D(a) \subset \bigcup_{i \in  I} D(h_i)$,
    that is,
    \[
      \mathcal{V}\left(\sum (h_i)\right)
      =
      \bigcap_{i \in  I} \mathcal{V}(h_i) \subset \mathcal{V}(a)
      ,
    \]
    or again phrased differently $a_i \in  \sqrt{\sum (h_i)}$.
    So there is $n\geq 1$ with $a^n \in \sum_I (h_i)$,
    i.e.~there are finitely many $b_i \in A$ such that
    $a^n = \sum b_i h_i$.
    But then, the corresponding finitely many $D(h_i)$ cover $D(a)$
    already.

    Note that this in fact shows that $\Spec A$ is quasi-compact,
    i.e.~every open cover has a finite subcover.
  \end{proof}

  \begin{claim}
    We can choose the $a_i$ and $h_i$ such that
    $h_ja_i=h_ia_j$ holds for $i$, $j \in I$
  \end{claim}

  \begin{proof}
    On $D(h_i) \cap  D(h_j) = D(h_i h_j)$,
    we have
    \[
      \varphi _{h_i h_j} \left( \frac { a_i } { h_i }  \right)
      =
      \frestriction{s}{D(h_i h_j)}
      =
      \varphi _{h_i h_j} \left( \frac { a_j } { h_j }  \right) 
    \]
    As we already know that $\varphi _{h_i h_j}$ is injective,
    we deduce that
    $\frac { a_i } { h_i } = \frac { a_j } { h_j }  \in  A_{h_i h_j}$.
    Thus, there exists $N_i \geq 1$ such that
    \begin{equation}
      \label{eq:proof-structure-sheaf-identity-local-ring-zero}
      (h_i h_j)^{N_i} (h_j a_i - h_i a_j) = 0
    \end{equation}
    As we can assume that $I$ is finite,
    we can set $N \coloneqq \max_I N_i$.
    Now, replace $h_i$ by $h_i^{N+1}$ and $a_i$ by $h_i^N a_i$ for each $i$.
    Then,
    \[
      h_j' a_i' - h_i' a_j'
      =
      h_j^{N+1} h_i^N a_i - h_i^{N+1} h_j^N a_j
      =
      0
    \]
    by
    \autoref{eq:proof-structure-sheaf-identity-local-ring-zero}.
  \end{proof}

  Then, since $D(a)=\bigcup_{i\in I}D(h_i)$,
  we find $n>0$ and $b_i\in A$ such that $a^n=\sum b_ih_i$.
  We write $c=\sum a_ib_i$.
  Then $h_jc=\sum_ia_ib_ih_j=\sum_ia_jb_ih_i=a^na_j$.
  It follows that $c/a_n=a_j/b_j\in A_{h_j}$. Hence $\varphi_a(c/a^n)=s$.
\end{proof}
